Index: src/edu/ucsb/nceas/metacat/ReplicationHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/ReplicationHandler.java	(revision 1291)
+++ src/edu/ucsb/nceas/metacat/ReplicationHandler.java	(revision 1292)
@@ -56,13 +56,13 @@
 {
   int serverCheckCode = 1;
   MetaCatUtil util = new MetaCatUtil();
-  Hashtable serverList = new Hashtable(); 
-  //Connection conn;
+  ReplicationServerList serverList = null; 
   PrintWriter out;
   
   public ReplicationHandler(PrintWriter o)
   {
     this.out = o;
+    serverList = new ReplicationServerList();
   }
   
   public ReplicationHandler(PrintWriter o, int serverCheckCode)
@@ -69,6 +69,7 @@
   {
     this.out = o;
     this.serverCheckCode = serverCheckCode;
+    serverList = new ReplicationServerList();
   }
   
   /**
@@ -82,39 +83,13 @@
     //xml_documents with an update_date > last_checked
     try
     {
-      //try
-      //{ //this connection is prone to error for some reason so we 
-        //try to connect it three times before quiting.
-        //conn = util.openDBConnection();
-      //}
-      //catch(SQLException sqle)
-      //{
-        /*try
-        {
-          conn = util.openDBConnection();
-        }
-        catch(SQLException sqlee)
-        {
-          try
-          {
-            conn = util.openDBConnection();
-          }
-          catch(SQLException sqleee)
-          {*/
-            //System.out.println("error getting db connection in " + 
-                               //"ReplicationHandler.run: " +
-                               //sqle.getMessage());
-          //}
-        //}
-      //}
-      serverList = buildServerList();
       //if serverList is null, metacat don't need to replication
       if (serverList==null||serverList.isEmpty())
       {
         return;
       }
-      updateCatalog(serverList);
-      update(serverList);
+      updateCatalog();
+      update();
       //conn.close();
     }//try
     catch (Exception e)
@@ -121,6 +96,7 @@
     {
       MetaCatUtil.debugMessage("Error in replicationHandler.run():"
                                                     +e.getMessage(), 30);
+      e.printStackTrace();
     }//catch
   }
   
@@ -127,7 +103,7 @@
   /**
    * Method that uses revision taging for replication instead of update_date.
    */
-  private void update(Hashtable serverList)
+  private void update()
   {
     /*
      Pseudo-algorithm
@@ -145,17 +121,11 @@
     
     DBConnection dbConn = null;
     int serialNumber = -1;
-    /*try
-    {
-      conn = util.getConnection();
-    }
-    catch (Exception e)
-    {
-      util.debugMessage("There is problem to get conncetion: "+e.getMessage());
-    }*/
-    
-    Enumeration keys;
-    String server;
+   
+    ReplicationServer replServer = null; // Variable to store the 
+                                        // ReplicationServer got from 
+                                        // Server list
+    String server; // Variable to store server name
     String update;
     ReplMessageHandler message = new ReplMessageHandler();
     Vector responses = new Vector();
@@ -162,7 +132,7 @@
     PreparedStatement pstmt = null;
     ResultSet rs;
     boolean tablehasrows;
-    boolean flag=false;
+    boolean flag=false; // If a document need to update
     boolean dataFile=false;
     String action = new String();
     XMLReader parser;
@@ -170,21 +140,39 @@
     
     try
     {
+      // Get DBConnection from pool
       dbConn=DBConnectionPool.
                   getDBConnection("ReplicationHandler.update");
       serialNumber=dbConn.getCheckOutSerialNumber();
-      MetaCatUtil.debugMessage("init parser");
+      MetaCatUtil.debugMessage("init parser", 50);
       parser = initParser(message);
-      keys = serverList.keys();
-      while(keys.hasMoreElements())
+      //Check for every server in server list
+      for (int i=0; i<serverList.size(); i++)
       {
-        server = (String)(keys.nextElement());
+        // Get ReplicationServer object from server list
+        replServer = serverList.serverAt(i);
+        // Get server name from ReplicationServer object
+        server = replServer.getServerName();
         MetacatReplication.replLog("full update started to: " + server);
+        // Send command to that server to get updated docid information
         u = new URL("https://" + server + "?server="
         +util.getLocalReplicationServerName()+"&action=update");
-        //System.out.println("Sending Message: " + u.toString());
-        String result = MetacatReplication.getURLContent(u);
-        //check if result have error or not
+        MetaCatUtil.debugMessage("Sending infomation " +u.toString(), 50);
+        // Get information from remote server
+        String result = null;
+        try
+        {
+          result = MetacatReplication.getURLContent(u);
+        }//try
+        catch (Exception e)
+        {
+          
+          MetaCatUtil.debugMessage("Error in get docid information from "+
+                                server+" :"+e.getMessage(), 30);
+          continue;
+        }//catch
+        MetaCatUtil.debugMessage("docid: "+server+" "+result, 50);
+        //check if result have error or not, if has skip it.
         if (result.indexOf("error")!=-1)
         {
           continue;
@@ -193,19 +181,18 @@
       }
       
       //make sure that there is updated file list
-      //If response is null, mecat don't need do anything
+      //If response is null, metacat don't need do anything
        if (responses==null||responses.isEmpty())
       {
         return;
       }
+     
       
-      //String srvr = util.getOption("servletpath");
+      MetaCatUtil.debugMessage("Responses from remote metacat about updated "+
+                   "document information: "+ responses.toString(), 30);
       
-      //System.out.println("responses (from srvr): " + responses.toString());
-      
       for(int i=0; i<responses.size(); i++)
       { //check each server for updated files
-        //System.out.println("parsing responses");
         parser.parse(new InputSource(
                      new StringReader(
                      (String)(responses.elementAt(i)))));
@@ -215,10 +202,10 @@
         //d is the list of deleted documents
         Vector d = new Vector(message.getDeletesVect());
         //System.out.println("d: " + d.toString());
+        MetaCatUtil.debugMessage("Update vector size: "+ v.size(), 40);
+        MetaCatUtil.debugMessage("Delete vector size: "+ d.size(),40);
         //check the revs in u to see if there are any newer ones than
         //in the local DB.
-        MetaCatUtil.debugMessage("Update vector size: "+ v.size(), 20);
-        MetaCatUtil.debugMessage("Delete vector size: "+ d.size(),20);
         for(int j=0; j<v.size(); j++)
         {
           //initial dataFile is false
@@ -233,24 +220,30 @@
             dataFile=true;
           }
           //System.out.println("w: " + w.toString());
+          // Get docid
           String docid = (String)w.elementAt(0);
           MetaCatUtil.debugMessage("docid: " + docid, 40);
+          // Get revision number
           int rev = Integer.parseInt((String)w.elementAt(1));
           MetaCatUtil.debugMessage("rev: " + rev, 40);
-          String docServer = (String)w.elementAt(2);
+          // Get remote server name (it is may not be doc homeserver because
+          // the new hub feature
+          String remoteServer = (String)w.elementAt(2);
           
-    
-         pstmt = dbConn.prepareStatement("select rev from xml_documents where "+
-                                        "docid like '" + docid + "'");
+          // Choose revision number from local host
+          pstmt = dbConn.prepareStatement("select rev from xml_documents where "
+                                            + "docid like '" + docid + "'");
           pstmt.execute();
           rs = pstmt.getResultSet();
           tablehasrows = rs.next();
           if(tablehasrows)
           { //check the revs for an update because this document is in the
-            //local DB, it just might be out of date.
+            //local DB, it might be out of date.
             int localrev = rs.getInt(1);
             if(localrev == rev)
             {
+              // Local meatacat has the same rev to remote host, don't need 
+              // update and flag set false
               flag = false;
             }
             else if(localrev < rev)
@@ -265,13 +258,20 @@
             flag = true;
           }
           
+          // Close result set
+          rs.close();
+          // Close preparedstatement
+          pstmt.close();
+          
           // this is non-data file
           if(flag && !dataFile)
           { //if the document needs to be updated or inserted, this is executed
-            u = new URL("https://" + docServer + "?server="+
+            u = new URL("https://" + remoteServer + "?server="+
               util.getLocalReplicationServerName()+"&action=read&docid="+docid);
             //System.out.println("Sending message: " + u.toString());
+            // Get docid content
             String newxmldoc = MetacatReplication.getURLContent(u);
+            // If couldn't get skip it
             if ( newxmldoc.indexOf("error")!= -1)
             {
               continue;
@@ -278,25 +278,27 @@
             }
             MetaCatUtil.debugMessage("xml documnet:", 50);
             MetaCatUtil.debugMessage(newxmldoc, 50);
+            
+            // Try get the docid info from remote server
             DocInfoHandler dih = new DocInfoHandler();
             XMLReader docinfoParser = initParser(dih);
-            URL docinfoUrl = new URL("https://" + docServer + 
+            URL docinfoUrl = new URL("https://" + remoteServer + 
                   "?server="+util.getLocalReplicationServerName()+
                   "&action=getdocumentinfo&docid="+docid);
-            //System.out.println("Sending message: " + docinfoUrl.toString());
+            MetaCatUtil.debugMessage("Sending message: " + 
+                                                  docinfoUrl.toString(), 50);
             String docInfoStr = MetacatReplication.getURLContent(docinfoUrl);
             docinfoParser.parse(new InputSource(new StringReader(docInfoStr)));
             Hashtable docinfoHash = dih.getDocInfo();
+            // Get home server of the docid
             String docHomeServer = (String)docinfoHash.get("home_server");
-            //int serverCode = MetacatReplication.getServerCode(docServer);
-            //System.out.println("updating doc: " + docid +" action: "+ action);
+                
             //docid should include rev number too
             String accnum=docid+util.getOption("accNumSeparator")+
                                               (String)docinfoHash.get("rev");
-            //System.out.println("accnum: "+accnum);
             try
             {
-             
+              // Write the document into local host
               String newDocid = DocumentImpl.writeReplication(dbConn, 
                               new StringReader(newxmldoc),
                               (String)docinfoHash.get("public_access"),
@@ -306,11 +308,12 @@
                               (String)docinfoHash.get("user_owner"),
                               null, /* null for groups[] */
                               docHomeServer, 
-                              false /* validate */);
+                              false /* validate */,
+                              remoteServer);
               //increase usage
               dbConn.increaseUsageCount(1);
               MetacatReplication.replLog("wrote doc " + docid + " from " + 
-                                         docServer);
+                                         remoteServer);
               /*System.out.println("wrote doc " + docid + " from " + 
                                  docServer);*/
             }
@@ -322,62 +325,70 @@
             }
           }//if for non-data file
           
-           // this is for data file and metacat is configured to accetp datafile
-          if(flag && dataFile 
-                   && (util.getOption("replicationacceptdata")).equals("on"))
+           // this is for data file
+          if(flag && dataFile)
           { 
             //if the document needs to be updated or inserted, this is executed
-            //String newxmldoc = MetacatReplication.getURLContent(u);
+            
+            // Try get docid info from remote server
             DocInfoHandler dih = new DocInfoHandler();
             XMLReader docinfoParser = initParser(dih);
-            URL docinfoUrl = new URL("https://" + docServer + 
+            URL docinfoUrl = new URL("https://" + remoteServer + 
                   "?server="+util.getLocalReplicationServerName()+
                   "&action=getdocumentinfo&docid="+docid);
-            //System.out.println("Sending message: " + docinfoUrl.toString());
+            
             String docInfoStr = MetacatReplication.getURLContent(docinfoUrl);
             docinfoParser.parse(new InputSource(new StringReader(docInfoStr)));
             Hashtable docinfoHash = dih.getDocInfo();
+            // Get doicd owner
             String user = (String)docinfoHash.get("user_owner");
+            // Get docid name (such as acl or dataset)
             String docName = (String)docinfoHash.get("docname");
+            // Get doc type (eml public id) 
             String docType = (String)docinfoHash.get("doctype");
+            // Get docid home sever. it might be different to remoteserver
+            // becuause of hub feature
             String docHomeServer = (String)docinfoHash.get("home_server");
-          
-            //int serverCode = MetacatReplication.getServerCode(docServer);
+         
             //System.out.println("updating doc: " + docid +" action: "+ action);
             //docid should include rev number too
             String accnum=docid+util.getOption("accNumSeparator")+
                                               (String)docinfoHash.get("rev");
             String datafilePath = util.getOption("datafilepath");
-            u = new URL("https://" + docServer + "?server="+
+            // Get data file content
+            u = new URL("https://" + remoteServer + "?server="+
                                         util.getLocalReplicationServerName()+
                                             "&action=readdata&docid="+accnum);
-            //System.out.println("accnum: "+accnum);
+           
             try
             {
-              
               //register data file into xml_documents table and wite data file
               //into file system
               if (u.openStream() != null)
               {
-              DocumentImpl.writeDataFile(u.openStream(), datafilePath, 
-                                  docName,docType, accnum, user,docHomeServer);
+                DocumentImpl.writeDataFileInReplication(u.openStream(), 
+                                                        datafilePath, 
+                                                        docName,docType, 
+                                                        accnum, user,
+                                                        docHomeServer,
+                                                        remoteServer);
               
-              MetacatReplication.replLog("wrote doc " + docid + " from " + 
-                                         docServer);
-              }
+                MetacatReplication.replLog("wrote doc " + docid + " from " + 
+                                         remoteServer);
+              }//if
               else
               {
+                // If get null, skip it
                 continue;
-              }
-              /*System.out.println("wrote doc " + docid + " from " + 
-                                 docServer);*/
-            }
+              }//else
+            
+            }//try
             catch(Exception e)
             {
               System.out.println("error writing document in " + 
                                  "ReplicationHandler.update: " + docid +
                                  ": " + e.getMessage());
-            }
+            }//catch
           }//for datafile
         }//for update docs
         
@@ -397,12 +408,16 @@
             MetacatReplication.replLog("doc " + docid + " deleted");
           }
         }//for delete docs
-        
-        //updated last_checked
-        keys = serverList.keys();
-        while(keys.hasMoreElements())
-        {
-          server = (String)(keys.nextElement()); 
+      }//for
+      
+      //updated last_checked
+      for (int i=0;i<serverList.size(); i++)
+      {
+          // Get ReplicationServer object from server list
+          replServer = serverList.serverAt(i);
+          // Get server name from ReplicationServer object
+          server = replServer.getServerName();
+          // Get time from remote server
           URL dateurl = new URL("https://" + server + "?server="+
           util.getLocalReplicationServerName()+"&action=gettime");
           String datexml = MetacatReplication.getURLContent(dateurl);
@@ -421,10 +436,9 @@
             dbConn.increaseUsageCount(1);
             pstmt.executeUpdate();
             dbConn.commit();
-            System.out.println("last_checked updated to " + datestr + " on " +
-                            server);
-          }
-        }//wile
+            MetaCatUtil.debugMessage("last_checked updated to "+datestr+" on " 
+                                      + server, 45);
+          }//if
       }//for
     }//try
     catch(Exception e)
@@ -437,7 +451,9 @@
     {
       try
       {
-        pstmt.close();
+        
+          pstmt.close();
+       
       }//try
       catch(Exception ee) 
       {
@@ -454,51 +470,42 @@
   /**
    * updates xml_catalog with entries from other servers.
    */
-  private void updateCatalog(Hashtable serverList)
+  private void updateCatalog()
   {
+    // DConnection
     DBConnection dbConn = null;
+    // DBConnection checkout serial number
     int serialNumber = -1;
+    // ReplicationServer object in server list
+    ReplicationServer replServer = null;
     PreparedStatement pstmt = null;
     try
     {
-      /*try
-      { 
-        conn = util.openDBConnection();
-      }
-      catch(SQLException sqle)
-      {
-        try
-        {
-          conn = util.openDBConnection();
-        }
-        catch(SQLException sqlee)
-        {
-          try
-          {
-            conn = util.openDBConnection();
-          }
-          catch(SQLException sqleee)
-          {
-            System.out.println("error getting db connection in " + 
-                               "ReplicationHandler.update: " +
-                               sqleee.getMessage());
-          }
-        }
-      }*/
-      
+
       dbConn=DBConnectionPool.
                   getDBConnection("ReplicationHandler.updateCatalog");
       serialNumber=dbConn.getCheckOutSerialNumber();
       String server;
-      Enumeration keys = serverList.keys();
-      while(keys.hasMoreElements())
-      { //go through each server
-        server = (String)(keys.nextElement());
+      
+      // Go through each ReplicationServer object in sererlist
+      for (int j=0; j<serverList.size(); j++)
+      { 
+        // Get ReplicationServer object from server list
+        replServer = serverList.serverAt(j);
+        // Get server name from the ReplicationServer object
+        server = replServer.getServerName();
+        // Try to get catalog
         URL u = new URL("https://" + server + "?server="+
         util.getLocalReplicationServerName()+"&action=getcatalog");
-        //System.out.println("sending message " + u.toString());
+        MetaCatUtil.debugMessage("sending message " + u.toString(), 50);
         String catxml = MetacatReplication.getURLContent(u);
-        //System.out.println("catxml: " + catxml);
+        
+        // Make sure there are not error, no empty string
+        if (catxml.indexOf("error")!=-1 || catxml==null||catxml.equals(""))
+        {
+          continue;
+        }
+        MetaCatUtil.debugMessage("catxml: " + catxml, 50);
         CatalogMessageHandler cmh = new CatalogMessageHandler();
         XMLReader catparser = initParser(cmh);
         catparser.parse(new InputSource(new StringReader(catxml)));
@@ -505,8 +512,20 @@
         //parse the returned catalog xml and put it into a vector
         Vector remoteCatalog = cmh.getCatalogVect();
         
+        // Makse sure remoteCatalog is not empty
+        if (remoteCatalog.isEmpty())
+        {
+          continue;
+        }
+        
         String localcatxml = MetacatReplication.getCatalogXML();
-        //System.out.println("localcatxml: " + localcatxml);
+        
+        // Make sure local catalog is no empty
+        if (localcatxml==null||localcatxml.equals(""))
+        {
+          continue;
+        }
+        
         cmh = new CatalogMessageHandler();
         catparser = initParser(cmh);
         catparser.parse(new InputSource(new StringReader(localcatxml)));
@@ -520,7 +539,7 @@
         for(int i=0; i<localCatalog.size(); i++)
         {
           Vector v = new Vector((Vector)localCatalog.elementAt(i));
-          //System.out.println("v1: " + v.toString());
+          MetaCatUtil.debugMessage("v1: " + v.toString(), 50);
           publicId.add(new String((String)v.elementAt(3)));
           //System.out.println("adding " + (String)v.elementAt(3));
         }
@@ -532,7 +551,8 @@
           //System.out.println("i: " + i);
           //System.out.println("remoteCatalog.size(): " + remoteCatalog.size());
           //System.out.println("publicID: " + publicId.toString());
-          //System.out.println("v.elementAt(3): " + (String)v.elementAt(3));
+          MetaCatUtil.debugMessage
+                              ("v.elementAt(3): " + (String)v.elementAt(3), 50);
           if(!publicId.contains(v.elementAt(3)))
           { //so we don't have this public id in our local table so we need to
             //add it.
@@ -555,7 +575,7 @@
           }
         }
       }
-      //conn.close();
+     
     }
     catch(Exception e)
     {
@@ -565,19 +585,7 @@
     }//catch
     finally
     {
-      try
-      {
-        pstmt.close();
-      }//try
-      catch (SQLException ee)
-      {
-        MetaCatUtil.debugMessage("Error in ReplicationHandler.updateCatalog "+
-                      "to close pstmt: "+ee.getMessage(), 30);
-      }//catch
-      finally
-      {
-        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
-      }//finally
+      DBConnectionPool.returnDBConnection(dbConn, serialNumber);
     }//finall
   }
   
@@ -674,292 +682,9 @@
     }//finally
     return false;
   }
-  
-  /**
-   * Checks to see if a document is already in the DB.  Returns
-   * "UPDATE" if it is, "INSERT" if it isn't
-   */
-  private static String getAction(String docid)
-  {
-    DBConnection dbConn = null;
-    int serialNumber = -1;
-    PreparedStatement pstmt = null;
-    try
-    {
-      dbConn=DBConnectionPool.
-                  getDBConnection("ReplicationHandler.getAction");
-      serialNumber=dbConn.getCheckOutSerialNumber();
-      //MetaCatUtil util = new MetaCatUtil();
-      StringBuffer sql = new StringBuffer();
-      sql.append("select docid from xml_documents where docid like '");
-      sql.append(docid).append("'");
-      //Connection conn = util.openDBConnection();
-      pstmt = dbConn.prepareStatement(sql.toString());
-      pstmt.execute();
-      ResultSet rs = pstmt.getResultSet();
 
-      if(rs.next())
-      {
-        pstmt.close();
-        //conn.close();
-        return "UPDATE";
-      }
-      else
-      {
-        pstmt.close();
-        //conn.close();
-        return "INSERT";
-      }
-    }
-    catch(Exception e)
-    {
-      System.out.println("error in replicationHandler.getAction: " + 
-                          e.getMessage());
-    }
-    finally
-    {
-      try
-      {
-        pstmt.close();
-      }
-      catch (SQLException sqlE)
-      {
-        MetaCatUtil.debugMessage("error in replicationHandler.getAction: " + 
-                     "to close pstmt: "+ sqlE.getMessage(), 30);
-      }
-      finally
-      {
-        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
-      }
-    }//finally
-    return "";
-  }
   
   /**
-   * Method to query xml_replication and build a hashtable of each server
-   * and it's last update time.
-   * @param conn a connection to the database
-   */
-  public static Hashtable buildServerList()
-  {
-    DBConnection dbConn = null;
-    int serialNumber = -1;
-    Hashtable sl = new Hashtable();
-    PreparedStatement pstmt = null;   
-    try
-    {
-      dbConn=DBConnectionPool.
-                  getDBConnection("ReplicationHandler.buildServerList");
-      serialNumber=dbConn.getCheckOutSerialNumber();
-      pstmt = dbConn.prepareStatement("select server, last_checked, replicate "+
-                                    "from xml_replication");
-      pstmt.execute();
-      ResultSet rs = pstmt.getResultSet();
-      boolean tableHasRows = rs.next();
-      while(tableHasRows)
-      {
-        if(rs.getInt(3) == 1)
-        {//only put the server in the list if the replicate flag is true
-          String server = rs.getString(1);
-          String last_checked = rs.getString(2);
-          if(!server.equals("localhost"))
-          {
-            sl.put(server, last_checked);
-          }
-        }
-        tableHasRows = rs.next();   
-      }
-      pstmt.close();
-    }
-    catch(Exception e)
-    {
-      System.out.println("error in replicationHandler.buildServerList(): " +
-                         e.getMessage());
-    }
-    finally
-    {
-      try
-      {
-        pstmt.close();
-      }//try
-      catch (SQLException sqlE)
-      {
-        MetaCatUtil.debugMessage("Error in ReplicationHandler.buildServerList: "
-                                +sqlE.getMessage());
-      }//catch
-      finally
-      {
-        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
-      }//finally
-    }//finally
-     
-    return sl;
-  }
-   /**
-   * Method to get a host server information for given docid
-   * @param conn a connection to the database
-   */
-  public static Hashtable getHomeServer(String docId)
-  {
-    Hashtable sl = new Hashtable();
-    DBConnection dbConn = null;
-    int serialNumber = -1;
-    //MetaCatUtil ut=new MetaCatUtil();
-    docId=MetaCatUtil.getDocIdFromString(docId);
-    PreparedStatement pstmt=null;
-    int serverLocation;
-    try
-    {
-      //get conection
-      dbConn=DBConnectionPool.
-                  getDBConnection("ReplicationHandler.getHomeServer");
-      serialNumber=dbConn.getCheckOutSerialNumber();
-      //get a server location from xml_document table
-      pstmt=dbConn.prepareStatement("select server_location from xml_documents "
-                                            +"where docid = ?");
-      pstmt.setString(1, docId);
-      pstmt.execute();
-      ResultSet serverName = pstmt.getResultSet();
-      //get a server location
-      if(serverName.next())
-      {
-        serverLocation=serverName.getInt(1);
-        pstmt.close();
-      }
-      else
-      {
-        pstmt.close();
-        //ut.returnConnection(conn);
-        return null;
-      }
-      pstmt=dbConn.prepareStatement("select server, last_checked, replicate " +
-                        "from xml_replication where serverid = ?");
-      //increase usage count
-      dbConn.increaseUsageCount(1);
-      pstmt.setInt(1, serverLocation);
-      pstmt.execute();
-      ResultSet rs = pstmt.getResultSet();
-      boolean tableHasRows = rs.next();
-      if (tableHasRows)
-      {
-        
-          String server = rs.getString(1);
-          String last_checked = rs.getString(2);
-          if(!server.equals("localhost"))
-          {
-            sl.put(server, last_checked);
-          }
-        
-      }
-      else
-      {
-        pstmt.close();
-        //ut.returnConnection(conn);
-        return null;
-      }
-      pstmt.close();
-    }
-    catch(Exception e)
-    {
-      System.out.println("error in replicationHandler.getHomeServer(): " +
-                         e.getMessage());
-    }
-    finally
-    {
-      try
-      {
-        pstmt.close();
-        //ut.returnConnection(conn);
-      }
-      catch (Exception ee)
-      {
-        MetaCatUtil.debugMessage("Eror irn rplicationHandler.getHomeServer() "+
-                          "to close pstmt: "+ee.getMessage(), 30);
-      }
-      finally
-      {
-        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
-      }
-    
-    }//finally
-    return sl;
-  }
-  
-  /**
-   * Returns a server location  given a accnum
-   * @param accNum , given accNum for a document
-   * 
-   */
-  public static int getServerLocation(String accNum) throws Exception
-  {
-    DBConnection dbConn = null;
-    int serialNumber = -1;
-    PreparedStatement pstmt = null;
-    int serverCode = 1;
-    //MetaCatUtil ut = new MetaCatUtil();
-    String docId=MetaCatUtil.getDocIdFromString(accNum);
-
-    try 
-    {
-
-      //conn = ut.openDBConnection();
-      //get conection
-      dbConn=DBConnectionPool.
-                  getDBConnection("ReplicationHandler.getServerLocation");
-      serialNumber=dbConn.getCheckOutSerialNumber();
-      pstmt=dbConn.prepareStatement("SELECT server_location FROM xml_documents " 
-                              + "WHERE docid LIKE '" + docId + "'");
-      pstmt.execute();
-      ResultSet rs = pstmt.getResultSet();
-      boolean tablehasrows = rs.next();
-      //If a document is find, return the server location for it
-      if ( tablehasrows ) 
-      {  
-        serverCode = rs.getInt(1);
-        pstmt.close();
-        //conn.close();
-        return serverCode;
-      }
-      //if couldn't find in xml_documents table, we think server code is 1
-      //(this is new document)
-      else
-      {
-        pstmt.close();
-        //conn.close();
-        return serverCode;
-      }
-      
-    } 
-    catch(Exception e) 
-    {
-      
-      throw e;
-
-    } 
-    finally 
-    {
-      try 
-      {
-        pstmt.close();
-        //conn.close();
-        
-      } 
-      catch(Exception ee) 
-      {
-        MetaCatUtil.debugMessage("Erorr in Replication.getServerLocation "+
-                     "to close pstmt"+ee.getMessage(), 30);
-      }
-      finally
-      {
-        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
-      }//finally
-    }//finally
-   //return serverCode;
-  }
-  
-  
-  
-  /**
    * Method to initialize the message parser
    */
   public static XMLReader initParser(DefaultHandler dh)
